//+------------------------------------------------------------------+
//|                                                      MaGrad.mq4 |
//|                       Copyright ?2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DarkTurquoise
//---- input parameters
extern int       myma=10;
extern int       myt=5;
//---- buffers
double ExtMapBuffer0[];
double ExtMapBuffer1[];
double ExtMapBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   IndicatorBuffers(3);  
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,0);
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,0);
   SetIndexBuffer(1,ExtMapBuffer1);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,ExtMapBuffer);
   IndicatorDigits(Digits+1);
   IndicatorShortName("MaGrad("+myma+","+myt+")");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++)
      ExtMapBuffer[i]=(iMA(NULL,0,myma,0,MODE_EMA,PRICE_CLOSE,i)
                      -iMA(NULL,0,myma,0,MODE_EMA,PRICE_CLOSE,i+myt))/myt;
   for(i=limit-1;i>=0; i--)
     {
      if(ExtMapBuffer[i]>ExtMapBuffer[i+1]) 
         {ExtMapBuffer0[i]=ExtMapBuffer[i];
          if (ExtMapBuffer[i+1]<ExtMapBuffer[i+2]) ExtMapBuffer0[i+1]=ExtMapBuffer[i+1];
         }

      if(ExtMapBuffer[i]<ExtMapBuffer[i+1]) 
         {ExtMapBuffer1[i]=ExtMapBuffer[i];
          if (ExtMapBuffer[i+1]>ExtMapBuffer[i+2]) ExtMapBuffer1[i+1]=ExtMapBuffer[i+1];
         }
     }
  }
//+------------------------------------------------------------------+

